#ifndef _ALTERA_DMA_CMD_H
#define _ALTERA_DMA_CMD_H
#include <linux/ioctl.h>

#define ALTERA_CMD_CLEAR 12
#define ALTERA_CMD_RCONT 13    //continue read loop
#define ALTERA_CMD_WCONT 14    //continue write loop
#define ALTERA_CMD_RSTART 15   //start DMA read loop
#define ALTERA_CMD_RWAIT 16    //suspend DMA read loop
#define ALTERA_CMD_WWAIT 17    //suspend event building loop
#define ALTERA_CMD_ACTSPAGE 18 //spage number for remapping (PK plays)

#define ALTERA_IOC_MAGIC 0x66
#define ALTERA_IOCX_CLEAR _IOW(ALTERA_IOC_MAGIC, ALTERA_CMD_CLEAR, unsigned long)
#define ALTERA_IOCX_RCONT _IOW(ALTERA_IOC_MAGIC, ALTERA_CMD_RCONT, unsigned long)
#define ALTERA_IOCX_WCONT _IOW(ALTERA_IOC_MAGIC, ALTERA_CMD_WCONT, unsigned long)
#define ALTERA_IOCX_RSTART _IOR(ALTERA_IOC_MAGIC, ALTERA_CMD_RSTART, unsigned long)
#define ALTERA_IOCX_RWAIT _IOW(ALTERA_IOC_MAGIC, ALTERA_CMD_RWAIT, unsigned long)
#define ALTERA_IOCX_WWAIT _IOR(ALTERA_IOC_MAGIC, ALTERA_CMD_WWAIT, unsigned long)

#ifndef __KERNEL__

#include <sys/ioctl.h>

#endif

struct dma_cmd
{
    int cmd;
    int usr_buf_size;
    char *buf;
};

#endif /* _ALTERA_DMA_CMD_H */
