#ifndef ECS_H
#define ECS_H

#ifdef __cplusplus
extern "C" {
#endif

void ecs_printSetup();

int  ecs_open(int dev, int bar);
void ecs_close(int dev, int bar);

int      ecs_write(int dev, int bar, unsigned add, int val);
unsigned ecs_read(int dev, int bar, unsigned add);
int      dma_launch( int dev , unsigned int ** data ) ;

// locks for slow control
int ecs_slc_lock( int dev , int ch ) ;
int ecs_slc_unlock( int dev , int ch ) ;

//Adaptation with old library
int ecs_iowrBar(int dev, int bar, unsigned add, unsigned *val);
int ecs_iordBar(int dev, int bar, unsigned add, unsigned *val);

// functions to use to access the LLI ressources
int ecs_openLli(int dev);
void ecs_closeLli(int dev);
int  ecs_iordLli(int dev, unsigned add, unsigned *val);
int  ecs_iowrLli(int dev, unsigned add, unsigned *val);

// functions to use to access the I2C core registers
int  ecs_iordI2c(int dev, unsigned add, unsigned *val);
int  ecs_iowrI2c(int dev, unsigned add, unsigned *val);
int  ecs_iordI2c_slow(int dev, unsigned add, unsigned *val);
int  ecs_iowrI2c_slow(int dev, unsigned add, unsigned *val);

#ifdef __cplusplus
}
#endif

#endif
